--grabadora tts 2 lista
require "import"
import "java.io.File"
import "java.io.FileReader"
import "java.io.FileWriter"
import "java.io.FileOutputStream"
import "java.io.FileInputStream"
import "android.media.AudioManager"
import "android.speech.tts.UtteranceProgressListener"
import "android.content.Intent"
import "android.content.Context"
import "android.widget.Toast"
import "java.lang.System"
import "android.speech.tts.TextToSpeech"
import "java.util.*"

folderPath = "/storage/emulated/0/Grabación con Plugin"
folder = File(folderPath)
if not folder.exists() then
    success = folder.mkdirs()
    if success then
        service.asyncSpeak("creado por sergio pina: " .. folderPath)
    else
        service.asyncSpeak("No se pudo crear la carpeta en: " .. folderPath)
    end
end

counterFile = File("/storage/emulated/0/orden.txt")
counterFile.delete()
context = activity or service

local textoIngresado = node.text or ""
local outputFile = "/storage/emulated/0/Grabación con Plugin/output"

local TTS = TextToSpeech(context, function(status)
    if status == TextToSpeech.ERROR then
        service.asyncSpeak("Error al inicializar TextToSpeech")
    else
        service.asyncSpeak("TextToSpeech inicializado exitosamente")
        readAloud()
    end
end)

TTS.setOnUtteranceProgressListener(UtteranceProgressListener{
    onStart = function(utteranceId)
        service.asyncSpeak("Mulai diproses ke audio: " .. utteranceId)
    end,

    onDone = function(utteranceId)
        service.asyncSpeak("Selesai diproses text ke audio: " .. utteranceId)
    end,

    onError = function(utteranceId)
        service.asyncSpeak("Error: " .. utteranceId)
    end
})

-- Divide el texto en fragmentos
local textChunks = {}
local maxChunkSize = 4000

while #textoIngresado > maxChunkSize do
    local chunkEnd = maxChunkSize
    while string.sub(textoIngresado, chunkEnd, chunkEnd) ~= " " and chunkEnd > 1 do
        chunkEnd = chunkEnd - 1
    end
    table.insert(textChunks, string.sub(textoIngresado, 1, chunkEnd))
    textoIngresado = string.sub(textoIngresado, chunkEnd + 1)
end
table.insert(textChunks, textoIngresado) -- Agrega el último fragmento

function readAloud()
    if TTS.isSpeaking() then
        TTS.stop()
        return
    end

    for i, textChunk in ipairs(textChunks) do
        service.asyncSpeak("Procesando fragmento " .. i)
        local params = {
            [TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID] = "utteranceId" .. i,
            [TextToSpeech.Engine.KEY_PARAM_STREAM] = tostring(AudioManager.STREAM_MUSIC)
        }
        local speakStatus = TTS.synthesizeToFile(textChunk, params, string.format("%s_%d.wav", outputFile, i))
        if speakStatus == TextToSpeech.ERROR then
            service.asyncSpeak("Error al llamar a TTS.synthesizeToFile para el fragmento " .. i)
        end
    end
end

function stopSpeaking()
    if TTS.isSpeaking() then
        TTS.stop()
    end
end

return true